/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg.springrestdocs;

/**
 *
 * @author omozegieaziegbe
 */
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;
import org.springframework.web.bind.annotation.RequestParam;

@RestController
public class BookController {
    
    private List<Book> books = new ArrayList<>();
    
    public BookController() {
        // Sample data for books
        books.add(new Book(1L, "The Great Gatsby", "F. Scott Fitzgerald", "Classic"));
        books.add(new Book(2L, "To Kill a Mockingbird", "Harper Lee", "Classic"));
        books.add(new Book(3L, "1984", "George Orwell", "Dystopian"));
        books.add(new Book(4L, "The Age of Reason", "Thomas Paine", "Philosophy"));
        books.add(new Book(5L, "The Catcher in the Rye", "J.D. Salinger", "Coming-of-age"));
        books.add(new Book(6L, "Pride and Prejudice", "Jane Austen", "Romance"));
        books.add(new Book(7L, "Spring in Action", "Craig Walls", "Programming"));
    }

     @GetMapping("/api/books")
    public List<Book> getBooks(@RequestParam(required = false) String genre,
                               @RequestParam(required = false) String author) {
        // Filter books based on query parameters
        List<Book> filteredBooks = books;

        if (genre != null) {
            filteredBooks = filteredBooks.stream()
                    .filter(book -> book.getGenre().equalsIgnoreCase(genre))
                    .collect(Collectors.toList());
        }

        if (author != null) {
            filteredBooks = filteredBooks.stream()
                    .filter(book -> book.getAuthor().equalsIgnoreCase(author))
                    .collect(Collectors.toList());
        }

        return filteredBooks;
    }
}
